{-# LANGUAGE NoImplicitPrelude #-}
{-# OPTIONS_GHC -fno-warn-duplicate-exports #-}
{-# OPTIONS_GHC -fno-warn-unused-imports #-}

-- Derived from AWS service descriptions, licensed under Apache 2.0.

-- |
-- Module      : Amazonka.DevOpsGuru.Lens
-- Copyright   : (c) 2013-2023 Brendan Hay
-- License     : Mozilla Public License, v. 2.0.
-- Maintainer  : Brendan Hay
-- Stability   : auto-generated
-- Portability : non-portable (GHC extensions)
module Amazonka.DevOpsGuru.Lens
  ( -- * Operations

    -- ** AddNotificationChannel
    addNotificationChannel_config,
    addNotificationChannelResponse_httpStatus,
    addNotificationChannelResponse_id,

    -- ** DeleteInsight
    deleteInsight_id,
    deleteInsightResponse_httpStatus,

    -- ** DescribeAccountHealth
    describeAccountHealthResponse_analyzedResourceCount,
    describeAccountHealthResponse_httpStatus,
    describeAccountHealthResponse_openReactiveInsights,
    describeAccountHealthResponse_openProactiveInsights,
    describeAccountHealthResponse_metricsAnalyzed,
    describeAccountHealthResponse_resourceHours,

    -- ** DescribeAccountOverview
    describeAccountOverview_toTime,
    describeAccountOverview_fromTime,
    describeAccountOverviewResponse_httpStatus,
    describeAccountOverviewResponse_reactiveInsights,
    describeAccountOverviewResponse_proactiveInsights,
    describeAccountOverviewResponse_meanTimeToRecoverInMilliseconds,

    -- ** DescribeAnomaly
    describeAnomaly_accountId,
    describeAnomaly_id,
    describeAnomalyResponse_proactiveAnomaly,
    describeAnomalyResponse_reactiveAnomaly,
    describeAnomalyResponse_httpStatus,

    -- ** DescribeEventSourcesConfig
    describeEventSourcesConfigResponse_eventSources,
    describeEventSourcesConfigResponse_httpStatus,

    -- ** DescribeFeedback
    describeFeedback_insightId,
    describeFeedbackResponse_insightFeedback,
    describeFeedbackResponse_httpStatus,

    -- ** DescribeInsight
    describeInsight_accountId,
    describeInsight_id,
    describeInsightResponse_proactiveInsight,
    describeInsightResponse_reactiveInsight,
    describeInsightResponse_httpStatus,

    -- ** DescribeOrganizationHealth
    describeOrganizationHealth_accountIds,
    describeOrganizationHealth_organizationalUnitIds,
    describeOrganizationHealthResponse_httpStatus,
    describeOrganizationHealthResponse_openReactiveInsights,
    describeOrganizationHealthResponse_openProactiveInsights,
    describeOrganizationHealthResponse_metricsAnalyzed,
    describeOrganizationHealthResponse_resourceHours,

    -- ** DescribeOrganizationOverview
    describeOrganizationOverview_accountIds,
    describeOrganizationOverview_organizationalUnitIds,
    describeOrganizationOverview_toTime,
    describeOrganizationOverview_fromTime,
    describeOrganizationOverviewResponse_httpStatus,
    describeOrganizationOverviewResponse_reactiveInsights,
    describeOrganizationOverviewResponse_proactiveInsights,

    -- ** DescribeOrganizationResourceCollectionHealth
    describeOrganizationResourceCollectionHealth_accountIds,
    describeOrganizationResourceCollectionHealth_maxResults,
    describeOrganizationResourceCollectionHealth_nextToken,
    describeOrganizationResourceCollectionHealth_organizationalUnitIds,
    describeOrganizationResourceCollectionHealth_organizationResourceCollectionType,
    describeOrganizationResourceCollectionHealthResponse_account,
    describeOrganizationResourceCollectionHealthResponse_cloudFormation,
    describeOrganizationResourceCollectionHealthResponse_nextToken,
    describeOrganizationResourceCollectionHealthResponse_service,
    describeOrganizationResourceCollectionHealthResponse_tags,
    describeOrganizationResourceCollectionHealthResponse_httpStatus,

    -- ** DescribeResourceCollectionHealth
    describeResourceCollectionHealth_nextToken,
    describeResourceCollectionHealth_resourceCollectionType,
    describeResourceCollectionHealthResponse_cloudFormation,
    describeResourceCollectionHealthResponse_nextToken,
    describeResourceCollectionHealthResponse_service,
    describeResourceCollectionHealthResponse_tags,
    describeResourceCollectionHealthResponse_httpStatus,

    -- ** DescribeServiceIntegration
    describeServiceIntegrationResponse_serviceIntegration,
    describeServiceIntegrationResponse_httpStatus,

    -- ** GetCostEstimation
    getCostEstimation_nextToken,
    getCostEstimationResponse_costs,
    getCostEstimationResponse_nextToken,
    getCostEstimationResponse_resourceCollection,
    getCostEstimationResponse_status,
    getCostEstimationResponse_timeRange,
    getCostEstimationResponse_totalCost,
    getCostEstimationResponse_httpStatus,

    -- ** GetResourceCollection
    getResourceCollection_nextToken,
    getResourceCollection_resourceCollectionType,
    getResourceCollectionResponse_nextToken,
    getResourceCollectionResponse_resourceCollection,
    getResourceCollectionResponse_httpStatus,

    -- ** ListAnomaliesForInsight
    listAnomaliesForInsight_accountId,
    listAnomaliesForInsight_maxResults,
    listAnomaliesForInsight_nextToken,
    listAnomaliesForInsight_startTimeRange,
    listAnomaliesForInsight_insightId,
    listAnomaliesForInsightResponse_nextToken,
    listAnomaliesForInsightResponse_proactiveAnomalies,
    listAnomaliesForInsightResponse_reactiveAnomalies,
    listAnomaliesForInsightResponse_httpStatus,

    -- ** ListAnomalousLogGroups
    listAnomalousLogGroups_maxResults,
    listAnomalousLogGroups_nextToken,
    listAnomalousLogGroups_insightId,
    listAnomalousLogGroupsResponse_nextToken,
    listAnomalousLogGroupsResponse_httpStatus,
    listAnomalousLogGroupsResponse_insightId,
    listAnomalousLogGroupsResponse_anomalousLogGroups,

    -- ** ListEvents
    listEvents_accountId,
    listEvents_maxResults,
    listEvents_nextToken,
    listEvents_filters,
    listEventsResponse_nextToken,
    listEventsResponse_httpStatus,
    listEventsResponse_events,

    -- ** ListInsights
    listInsights_maxResults,
    listInsights_nextToken,
    listInsights_statusFilter,
    listInsightsResponse_nextToken,
    listInsightsResponse_proactiveInsights,
    listInsightsResponse_reactiveInsights,
    listInsightsResponse_httpStatus,

    -- ** ListMonitoredResources
    listMonitoredResources_filters,
    listMonitoredResources_maxResults,
    listMonitoredResources_nextToken,
    listMonitoredResourcesResponse_nextToken,
    listMonitoredResourcesResponse_httpStatus,
    listMonitoredResourcesResponse_monitoredResourceIdentifiers,

    -- ** ListNotificationChannels
    listNotificationChannels_nextToken,
    listNotificationChannelsResponse_channels,
    listNotificationChannelsResponse_nextToken,
    listNotificationChannelsResponse_httpStatus,

    -- ** ListOrganizationInsights
    listOrganizationInsights_accountIds,
    listOrganizationInsights_maxResults,
    listOrganizationInsights_nextToken,
    listOrganizationInsights_organizationalUnitIds,
    listOrganizationInsights_statusFilter,
    listOrganizationInsightsResponse_nextToken,
    listOrganizationInsightsResponse_proactiveInsights,
    listOrganizationInsightsResponse_reactiveInsights,
    listOrganizationInsightsResponse_httpStatus,

    -- ** ListRecommendations
    listRecommendations_accountId,
    listRecommendations_locale,
    listRecommendations_nextToken,
    listRecommendations_insightId,
    listRecommendationsResponse_nextToken,
    listRecommendationsResponse_recommendations,
    listRecommendationsResponse_httpStatus,

    -- ** PutFeedback
    putFeedback_insightFeedback,
    putFeedbackResponse_httpStatus,

    -- ** RemoveNotificationChannel
    removeNotificationChannel_id,
    removeNotificationChannelResponse_httpStatus,

    -- ** SearchInsights
    searchInsights_filters,
    searchInsights_maxResults,
    searchInsights_nextToken,
    searchInsights_startTimeRange,
    searchInsights_type,
    searchInsightsResponse_nextToken,
    searchInsightsResponse_proactiveInsights,
    searchInsightsResponse_reactiveInsights,
    searchInsightsResponse_httpStatus,

    -- ** SearchOrganizationInsights
    searchOrganizationInsights_filters,
    searchOrganizationInsights_maxResults,
    searchOrganizationInsights_nextToken,
    searchOrganizationInsights_accountIds,
    searchOrganizationInsights_startTimeRange,
    searchOrganizationInsights_type,
    searchOrganizationInsightsResponse_nextToken,
    searchOrganizationInsightsResponse_proactiveInsights,
    searchOrganizationInsightsResponse_reactiveInsights,
    searchOrganizationInsightsResponse_httpStatus,

    -- ** StartCostEstimation
    startCostEstimation_clientToken,
    startCostEstimation_resourceCollection,
    startCostEstimationResponse_httpStatus,

    -- ** UpdateEventSourcesConfig
    updateEventSourcesConfig_eventSources,
    updateEventSourcesConfigResponse_httpStatus,

    -- ** UpdateResourceCollection
    updateResourceCollection_action,
    updateResourceCollection_resourceCollection,
    updateResourceCollectionResponse_httpStatus,

    -- ** UpdateServiceIntegration
    updateServiceIntegration_serviceIntegration,
    updateServiceIntegrationResponse_httpStatus,

    -- * Types

    -- ** AccountHealth
    accountHealth_accountId,
    accountHealth_insight,

    -- ** AccountInsightHealth
    accountInsightHealth_openProactiveInsights,
    accountInsightHealth_openReactiveInsights,

    -- ** AmazonCodeGuruProfilerIntegration
    amazonCodeGuruProfilerIntegration_status,

    -- ** AnomalousLogGroup
    anomalousLogGroup_impactEndTime,
    anomalousLogGroup_impactStartTime,
    anomalousLogGroup_logAnomalyShowcases,
    anomalousLogGroup_logGroupName,
    anomalousLogGroup_numberOfLogLinesScanned,

    -- ** AnomalyReportedTimeRange
    anomalyReportedTimeRange_closeTime,
    anomalyReportedTimeRange_openTime,

    -- ** AnomalyResource
    anomalyResource_name,
    anomalyResource_type,

    -- ** AnomalySourceDetails
    anomalySourceDetails_cloudWatchMetrics,
    anomalySourceDetails_performanceInsightsMetrics,

    -- ** AnomalySourceMetadata
    anomalySourceMetadata_source,
    anomalySourceMetadata_sourceResourceName,
    anomalySourceMetadata_sourceResourceType,

    -- ** AnomalyTimeRange
    anomalyTimeRange_endTime,
    anomalyTimeRange_startTime,

    -- ** CloudFormationCollection
    cloudFormationCollection_stackNames,

    -- ** CloudFormationCollectionFilter
    cloudFormationCollectionFilter_stackNames,

    -- ** CloudFormationCostEstimationResourceCollectionFilter
    cloudFormationCostEstimationResourceCollectionFilter_stackNames,

    -- ** CloudFormationHealth
    cloudFormationHealth_analyzedResourceCount,
    cloudFormationHealth_insight,
    cloudFormationHealth_stackName,

    -- ** CloudWatchMetricsDataSummary
    cloudWatchMetricsDataSummary_statusCode,
    cloudWatchMetricsDataSummary_timestampMetricValuePairList,

    -- ** CloudWatchMetricsDetail
    cloudWatchMetricsDetail_dimensions,
    cloudWatchMetricsDetail_metricDataSummary,
    cloudWatchMetricsDetail_metricName,
    cloudWatchMetricsDetail_namespace,
    cloudWatchMetricsDetail_period,
    cloudWatchMetricsDetail_stat,
    cloudWatchMetricsDetail_unit,

    -- ** CloudWatchMetricsDimension
    cloudWatchMetricsDimension_name,
    cloudWatchMetricsDimension_value,

    -- ** CostEstimationResourceCollectionFilter
    costEstimationResourceCollectionFilter_cloudFormation,
    costEstimationResourceCollectionFilter_tags,

    -- ** CostEstimationTimeRange
    costEstimationTimeRange_endTime,
    costEstimationTimeRange_startTime,

    -- ** EndTimeRange
    endTimeRange_fromTime,
    endTimeRange_toTime,

    -- ** Event
    event_dataSource,
    event_eventClass,
    event_eventSource,
    event_id,
    event_name,
    event_resourceCollection,
    event_resources,
    event_time,

    -- ** EventResource
    eventResource_arn,
    eventResource_name,
    eventResource_type,

    -- ** EventSourcesConfig
    eventSourcesConfig_amazonCodeGuruProfiler,

    -- ** EventTimeRange
    eventTimeRange_fromTime,
    eventTimeRange_toTime,

    -- ** InsightFeedback
    insightFeedback_feedback,
    insightFeedback_id,

    -- ** InsightHealth
    insightHealth_meanTimeToRecoverInMilliseconds,
    insightHealth_openProactiveInsights,
    insightHealth_openReactiveInsights,

    -- ** InsightTimeRange
    insightTimeRange_endTime,
    insightTimeRange_startTime,

    -- ** ListEventsFilters
    listEventsFilters_dataSource,
    listEventsFilters_eventClass,
    listEventsFilters_eventSource,
    listEventsFilters_eventTimeRange,
    listEventsFilters_insightId,
    listEventsFilters_resourceCollection,

    -- ** ListInsightsAnyStatusFilter
    listInsightsAnyStatusFilter_type,
    listInsightsAnyStatusFilter_startTimeRange,

    -- ** ListInsightsClosedStatusFilter
    listInsightsClosedStatusFilter_type,
    listInsightsClosedStatusFilter_endTimeRange,

    -- ** ListInsightsOngoingStatusFilter
    listInsightsOngoingStatusFilter_type,

    -- ** ListInsightsStatusFilter
    listInsightsStatusFilter_any,
    listInsightsStatusFilter_closed,
    listInsightsStatusFilter_ongoing,

    -- ** ListMonitoredResourcesFilters
    listMonitoredResourcesFilters_resourcePermission,
    listMonitoredResourcesFilters_resourceTypeFilters,

    -- ** LogAnomalyClass
    logAnomalyClass_explanation,
    logAnomalyClass_logAnomalyToken,
    logAnomalyClass_logAnomalyType,
    logAnomalyClass_logEventId,
    logAnomalyClass_logEventTimestamp,
    logAnomalyClass_logStreamName,
    logAnomalyClass_numberOfLogLinesOccurrences,

    -- ** LogAnomalyShowcase
    logAnomalyShowcase_logAnomalyClasses,

    -- ** LogsAnomalyDetectionIntegration
    logsAnomalyDetectionIntegration_optInStatus,

    -- ** LogsAnomalyDetectionIntegrationConfig
    logsAnomalyDetectionIntegrationConfig_optInStatus,

    -- ** MonitoredResourceIdentifier
    monitoredResourceIdentifier_lastUpdated,
    monitoredResourceIdentifier_monitoredResourceName,
    monitoredResourceIdentifier_resourceCollection,
    monitoredResourceIdentifier_resourcePermission,
    monitoredResourceIdentifier_type,

    -- ** NotificationChannel
    notificationChannel_config,
    notificationChannel_id,

    -- ** NotificationChannelConfig
    notificationChannelConfig_filters,
    notificationChannelConfig_sns,

    -- ** NotificationFilterConfig
    notificationFilterConfig_messageTypes,
    notificationFilterConfig_severities,

    -- ** OpsCenterIntegration
    opsCenterIntegration_optInStatus,

    -- ** OpsCenterIntegrationConfig
    opsCenterIntegrationConfig_optInStatus,

    -- ** PerformanceInsightsMetricDimensionGroup
    performanceInsightsMetricDimensionGroup_dimensions,
    performanceInsightsMetricDimensionGroup_group,
    performanceInsightsMetricDimensionGroup_limit,

    -- ** PerformanceInsightsMetricQuery
    performanceInsightsMetricQuery_filter,
    performanceInsightsMetricQuery_groupBy,
    performanceInsightsMetricQuery_metric,

    -- ** PerformanceInsightsMetricsDetail
    performanceInsightsMetricsDetail_metricDisplayName,
    performanceInsightsMetricsDetail_metricQuery,
    performanceInsightsMetricsDetail_referenceData,
    performanceInsightsMetricsDetail_statsAtAnomaly,
    performanceInsightsMetricsDetail_statsAtBaseline,
    performanceInsightsMetricsDetail_unit,

    -- ** PerformanceInsightsReferenceComparisonValues
    performanceInsightsReferenceComparisonValues_referenceMetric,
    performanceInsightsReferenceComparisonValues_referenceScalar,

    -- ** PerformanceInsightsReferenceData
    performanceInsightsReferenceData_comparisonValues,
    performanceInsightsReferenceData_name,

    -- ** PerformanceInsightsReferenceMetric
    performanceInsightsReferenceMetric_metricQuery,

    -- ** PerformanceInsightsReferenceScalar
    performanceInsightsReferenceScalar_value,

    -- ** PerformanceInsightsStat
    performanceInsightsStat_type,
    performanceInsightsStat_value,

    -- ** PredictionTimeRange
    predictionTimeRange_endTime,
    predictionTimeRange_startTime,

    -- ** ProactiveAnomaly
    proactiveAnomaly_anomalyReportedTimeRange,
    proactiveAnomaly_anomalyResources,
    proactiveAnomaly_anomalyTimeRange,
    proactiveAnomaly_associatedInsightId,
    proactiveAnomaly_id,
    proactiveAnomaly_limit,
    proactiveAnomaly_predictionTimeRange,
    proactiveAnomaly_resourceCollection,
    proactiveAnomaly_severity,
    proactiveAnomaly_sourceDetails,
    proactiveAnomaly_sourceMetadata,
    proactiveAnomaly_status,
    proactiveAnomaly_updateTime,

    -- ** ProactiveAnomalySummary
    proactiveAnomalySummary_anomalyReportedTimeRange,
    proactiveAnomalySummary_anomalyResources,
    proactiveAnomalySummary_anomalyTimeRange,
    proactiveAnomalySummary_associatedInsightId,
    proactiveAnomalySummary_id,
    proactiveAnomalySummary_limit,
    proactiveAnomalySummary_predictionTimeRange,
    proactiveAnomalySummary_resourceCollection,
    proactiveAnomalySummary_severity,
    proactiveAnomalySummary_sourceDetails,
    proactiveAnomalySummary_sourceMetadata,
    proactiveAnomalySummary_status,
    proactiveAnomalySummary_updateTime,

    -- ** ProactiveInsight
    proactiveInsight_description,
    proactiveInsight_id,
    proactiveInsight_insightTimeRange,
    proactiveInsight_name,
    proactiveInsight_predictionTimeRange,
    proactiveInsight_resourceCollection,
    proactiveInsight_severity,
    proactiveInsight_ssmOpsItemId,
    proactiveInsight_status,

    -- ** ProactiveInsightSummary
    proactiveInsightSummary_associatedResourceArns,
    proactiveInsightSummary_id,
    proactiveInsightSummary_insightTimeRange,
    proactiveInsightSummary_name,
    proactiveInsightSummary_predictionTimeRange,
    proactiveInsightSummary_resourceCollection,
    proactiveInsightSummary_serviceCollection,
    proactiveInsightSummary_severity,
    proactiveInsightSummary_status,

    -- ** ProactiveOrganizationInsightSummary
    proactiveOrganizationInsightSummary_accountId,
    proactiveOrganizationInsightSummary_id,
    proactiveOrganizationInsightSummary_insightTimeRange,
    proactiveOrganizationInsightSummary_name,
    proactiveOrganizationInsightSummary_organizationalUnitId,
    proactiveOrganizationInsightSummary_predictionTimeRange,
    proactiveOrganizationInsightSummary_resourceCollection,
    proactiveOrganizationInsightSummary_serviceCollection,
    proactiveOrganizationInsightSummary_severity,
    proactiveOrganizationInsightSummary_status,

    -- ** ReactiveAnomaly
    reactiveAnomaly_anomalyReportedTimeRange,
    reactiveAnomaly_anomalyResources,
    reactiveAnomaly_anomalyTimeRange,
    reactiveAnomaly_associatedInsightId,
    reactiveAnomaly_causalAnomalyId,
    reactiveAnomaly_description,
    reactiveAnomaly_id,
    reactiveAnomaly_name,
    reactiveAnomaly_resourceCollection,
    reactiveAnomaly_severity,
    reactiveAnomaly_sourceDetails,
    reactiveAnomaly_status,
    reactiveAnomaly_type,

    -- ** ReactiveAnomalySummary
    reactiveAnomalySummary_anomalyReportedTimeRange,
    reactiveAnomalySummary_anomalyResources,
    reactiveAnomalySummary_anomalyTimeRange,
    reactiveAnomalySummary_associatedInsightId,
    reactiveAnomalySummary_causalAnomalyId,
    reactiveAnomalySummary_description,
    reactiveAnomalySummary_id,
    reactiveAnomalySummary_name,
    reactiveAnomalySummary_resourceCollection,
    reactiveAnomalySummary_severity,
    reactiveAnomalySummary_sourceDetails,
    reactiveAnomalySummary_status,
    reactiveAnomalySummary_type,

    -- ** ReactiveInsight
    reactiveInsight_description,
    reactiveInsight_id,
    reactiveInsight_insightTimeRange,
    reactiveInsight_name,
    reactiveInsight_resourceCollection,
    reactiveInsight_severity,
    reactiveInsight_ssmOpsItemId,
    reactiveInsight_status,

    -- ** ReactiveInsightSummary
    reactiveInsightSummary_associatedResourceArns,
    reactiveInsightSummary_id,
    reactiveInsightSummary_insightTimeRange,
    reactiveInsightSummary_name,
    reactiveInsightSummary_resourceCollection,
    reactiveInsightSummary_serviceCollection,
    reactiveInsightSummary_severity,
    reactiveInsightSummary_status,

    -- ** ReactiveOrganizationInsightSummary
    reactiveOrganizationInsightSummary_accountId,
    reactiveOrganizationInsightSummary_id,
    reactiveOrganizationInsightSummary_insightTimeRange,
    reactiveOrganizationInsightSummary_name,
    reactiveOrganizationInsightSummary_organizationalUnitId,
    reactiveOrganizationInsightSummary_resourceCollection,
    reactiveOrganizationInsightSummary_serviceCollection,
    reactiveOrganizationInsightSummary_severity,
    reactiveOrganizationInsightSummary_status,

    -- ** Recommendation
    recommendation_category,
    recommendation_description,
    recommendation_link,
    recommendation_name,
    recommendation_reason,
    recommendation_relatedAnomalies,
    recommendation_relatedEvents,

    -- ** RecommendationRelatedAnomaly
    recommendationRelatedAnomaly_anomalyId,
    recommendationRelatedAnomaly_resources,
    recommendationRelatedAnomaly_sourceDetails,

    -- ** RecommendationRelatedAnomalyResource
    recommendationRelatedAnomalyResource_name,
    recommendationRelatedAnomalyResource_type,

    -- ** RecommendationRelatedAnomalySourceDetail
    recommendationRelatedAnomalySourceDetail_cloudWatchMetrics,

    -- ** RecommendationRelatedCloudWatchMetricsSourceDetail
    recommendationRelatedCloudWatchMetricsSourceDetail_metricName,
    recommendationRelatedCloudWatchMetricsSourceDetail_namespace,

    -- ** RecommendationRelatedEvent
    recommendationRelatedEvent_name,
    recommendationRelatedEvent_resources,

    -- ** RecommendationRelatedEventResource
    recommendationRelatedEventResource_name,
    recommendationRelatedEventResource_type,

    -- ** ResourceCollection
    resourceCollection_cloudFormation,
    resourceCollection_tags,

    -- ** ResourceCollectionFilter
    resourceCollectionFilter_cloudFormation,
    resourceCollectionFilter_tags,

    -- ** SearchInsightsFilters
    searchInsightsFilters_resourceCollection,
    searchInsightsFilters_serviceCollection,
    searchInsightsFilters_severities,
    searchInsightsFilters_statuses,

    -- ** SearchOrganizationInsightsFilters
    searchOrganizationInsightsFilters_resourceCollection,
    searchOrganizationInsightsFilters_serviceCollection,
    searchOrganizationInsightsFilters_severities,
    searchOrganizationInsightsFilters_statuses,

    -- ** ServiceCollection
    serviceCollection_serviceNames,

    -- ** ServiceHealth
    serviceHealth_analyzedResourceCount,
    serviceHealth_insight,
    serviceHealth_serviceName,

    -- ** ServiceInsightHealth
    serviceInsightHealth_openProactiveInsights,
    serviceInsightHealth_openReactiveInsights,

    -- ** ServiceIntegrationConfig
    serviceIntegrationConfig_logsAnomalyDetection,
    serviceIntegrationConfig_opsCenter,

    -- ** ServiceResourceCost
    serviceResourceCost_cost,
    serviceResourceCost_count,
    serviceResourceCost_state,
    serviceResourceCost_type,
    serviceResourceCost_unitCost,

    -- ** SnsChannelConfig
    snsChannelConfig_topicArn,

    -- ** StartTimeRange
    startTimeRange_fromTime,
    startTimeRange_toTime,

    -- ** TagCollection
    tagCollection_appBoundaryKey,
    tagCollection_tagValues,

    -- ** TagCollectionFilter
    tagCollectionFilter_appBoundaryKey,
    tagCollectionFilter_tagValues,

    -- ** TagCostEstimationResourceCollectionFilter
    tagCostEstimationResourceCollectionFilter_appBoundaryKey,
    tagCostEstimationResourceCollectionFilter_tagValues,

    -- ** TagHealth
    tagHealth_analyzedResourceCount,
    tagHealth_appBoundaryKey,
    tagHealth_insight,
    tagHealth_tagValue,

    -- ** TimestampMetricValuePair
    timestampMetricValuePair_metricValue,
    timestampMetricValuePair_timestamp,

    -- ** UpdateCloudFormationCollectionFilter
    updateCloudFormationCollectionFilter_stackNames,

    -- ** UpdateResourceCollectionFilter
    updateResourceCollectionFilter_cloudFormation,
    updateResourceCollectionFilter_tags,

    -- ** UpdateServiceIntegrationConfig
    updateServiceIntegrationConfig_logsAnomalyDetection,
    updateServiceIntegrationConfig_opsCenter,

    -- ** UpdateTagCollectionFilter
    updateTagCollectionFilter_appBoundaryKey,
    updateTagCollectionFilter_tagValues,
  )
where

import Amazonka.DevOpsGuru.AddNotificationChannel
import Amazonka.DevOpsGuru.DeleteInsight
import Amazonka.DevOpsGuru.DescribeAccountHealth
import Amazonka.DevOpsGuru.DescribeAccountOverview
import Amazonka.DevOpsGuru.DescribeAnomaly
import Amazonka.DevOpsGuru.DescribeEventSourcesConfig
import Amazonka.DevOpsGuru.DescribeFeedback
import Amazonka.DevOpsGuru.DescribeInsight
import Amazonka.DevOpsGuru.DescribeOrganizationHealth
import Amazonka.DevOpsGuru.DescribeOrganizationOverview
import Amazonka.DevOpsGuru.DescribeOrganizationResourceCollectionHealth
import Amazonka.DevOpsGuru.DescribeResourceCollectionHealth
import Amazonka.DevOpsGuru.DescribeServiceIntegration
import Amazonka.DevOpsGuru.GetCostEstimation
import Amazonka.DevOpsGuru.GetResourceCollection
import Amazonka.DevOpsGuru.ListAnomaliesForInsight
import Amazonka.DevOpsGuru.ListAnomalousLogGroups
import Amazonka.DevOpsGuru.ListEvents
import Amazonka.DevOpsGuru.ListInsights
import Amazonka.DevOpsGuru.ListMonitoredResources
import Amazonka.DevOpsGuru.ListNotificationChannels
import Amazonka.DevOpsGuru.ListOrganizationInsights
import Amazonka.DevOpsGuru.ListRecommendations
import Amazonka.DevOpsGuru.PutFeedback
import Amazonka.DevOpsGuru.RemoveNotificationChannel
import Amazonka.DevOpsGuru.SearchInsights
import Amazonka.DevOpsGuru.SearchOrganizationInsights
import Amazonka.DevOpsGuru.StartCostEstimation
import Amazonka.DevOpsGuru.Types.AccountHealth
import Amazonka.DevOpsGuru.Types.AccountInsightHealth
import Amazonka.DevOpsGuru.Types.AmazonCodeGuruProfilerIntegration
import Amazonka.DevOpsGuru.Types.AnomalousLogGroup
import Amazonka.DevOpsGuru.Types.AnomalyReportedTimeRange
import Amazonka.DevOpsGuru.Types.AnomalyResource
import Amazonka.DevOpsGuru.Types.AnomalySourceDetails
import Amazonka.DevOpsGuru.Types.AnomalySourceMetadata
import Amazonka.DevOpsGuru.Types.AnomalyTimeRange
import Amazonka.DevOpsGuru.Types.CloudFormationCollection
import Amazonka.DevOpsGuru.Types.CloudFormationCollectionFilter
import Amazonka.DevOpsGuru.Types.CloudFormationCostEstimationResourceCollectionFilter
import Amazonka.DevOpsGuru.Types.CloudFormationHealth
import Amazonka.DevOpsGuru.Types.CloudWatchMetricsDataSummary
import Amazonka.DevOpsGuru.Types.CloudWatchMetricsDetail
import Amazonka.DevOpsGuru.Types.CloudWatchMetricsDimension
import Amazonka.DevOpsGuru.Types.CostEstimationResourceCollectionFilter
import Amazonka.DevOpsGuru.Types.CostEstimationTimeRange
import Amazonka.DevOpsGuru.Types.EndTimeRange
import Amazonka.DevOpsGuru.Types.Event
import Amazonka.DevOpsGuru.Types.EventResource
import Amazonka.DevOpsGuru.Types.EventSourcesConfig
import Amazonka.DevOpsGuru.Types.EventTimeRange
import Amazonka.DevOpsGuru.Types.InsightFeedback
import Amazonka.DevOpsGuru.Types.InsightHealth
import Amazonka.DevOpsGuru.Types.InsightTimeRange
import Amazonka.DevOpsGuru.Types.ListEventsFilters
import Amazonka.DevOpsGuru.Types.ListInsightsAnyStatusFilter
import Amazonka.DevOpsGuru.Types.ListInsightsClosedStatusFilter
import Amazonka.DevOpsGuru.Types.ListInsightsOngoingStatusFilter
import Amazonka.DevOpsGuru.Types.ListInsightsStatusFilter
import Amazonka.DevOpsGuru.Types.ListMonitoredResourcesFilters
import Amazonka.DevOpsGuru.Types.LogAnomalyClass
import Amazonka.DevOpsGuru.Types.LogAnomalyShowcase
import Amazonka.DevOpsGuru.Types.LogsAnomalyDetectionIntegration
import Amazonka.DevOpsGuru.Types.LogsAnomalyDetectionIntegrationConfig
import Amazonka.DevOpsGuru.Types.MonitoredResourceIdentifier
import Amazonka.DevOpsGuru.Types.NotificationChannel
import Amazonka.DevOpsGuru.Types.NotificationChannelConfig
import Amazonka.DevOpsGuru.Types.NotificationFilterConfig
import Amazonka.DevOpsGuru.Types.OpsCenterIntegration
import Amazonka.DevOpsGuru.Types.OpsCenterIntegrationConfig
import Amazonka.DevOpsGuru.Types.PerformanceInsightsMetricDimensionGroup
import Amazonka.DevOpsGuru.Types.PerformanceInsightsMetricQuery
import Amazonka.DevOpsGuru.Types.PerformanceInsightsMetricsDetail
import Amazonka.DevOpsGuru.Types.PerformanceInsightsReferenceComparisonValues
import Amazonka.DevOpsGuru.Types.PerformanceInsightsReferenceData
import Amazonka.DevOpsGuru.Types.PerformanceInsightsReferenceMetric
import Amazonka.DevOpsGuru.Types.PerformanceInsightsReferenceScalar
import Amazonka.DevOpsGuru.Types.PerformanceInsightsStat
import Amazonka.DevOpsGuru.Types.PredictionTimeRange
import Amazonka.DevOpsGuru.Types.ProactiveAnomaly
import Amazonka.DevOpsGuru.Types.ProactiveAnomalySummary
import Amazonka.DevOpsGuru.Types.ProactiveInsight
import Amazonka.DevOpsGuru.Types.ProactiveInsightSummary
import Amazonka.DevOpsGuru.Types.ProactiveOrganizationInsightSummary
import Amazonka.DevOpsGuru.Types.ReactiveAnomaly
import Amazonka.DevOpsGuru.Types.ReactiveAnomalySummary
import Amazonka.DevOpsGuru.Types.ReactiveInsight
import Amazonka.DevOpsGuru.Types.ReactiveInsightSummary
import Amazonka.DevOpsGuru.Types.ReactiveOrganizationInsightSummary
import Amazonka.DevOpsGuru.Types.Recommendation
import Amazonka.DevOpsGuru.Types.RecommendationRelatedAnomaly
import Amazonka.DevOpsGuru.Types.RecommendationRelatedAnomalyResource
import Amazonka.DevOpsGuru.Types.RecommendationRelatedAnomalySourceDetail
import Amazonka.DevOpsGuru.Types.RecommendationRelatedCloudWatchMetricsSourceDetail
import Amazonka.DevOpsGuru.Types.RecommendationRelatedEvent
import Amazonka.DevOpsGuru.Types.RecommendationRelatedEventResource
import Amazonka.DevOpsGuru.Types.ResourceCollection
import Amazonka.DevOpsGuru.Types.ResourceCollectionFilter
import Amazonka.DevOpsGuru.Types.SearchInsightsFilters
import Amazonka.DevOpsGuru.Types.SearchOrganizationInsightsFilters
import Amazonka.DevOpsGuru.Types.ServiceCollection
import Amazonka.DevOpsGuru.Types.ServiceHealth
import Amazonka.DevOpsGuru.Types.ServiceInsightHealth
import Amazonka.DevOpsGuru.Types.ServiceIntegrationConfig
import Amazonka.DevOpsGuru.Types.ServiceResourceCost
import Amazonka.DevOpsGuru.Types.SnsChannelConfig
import Amazonka.DevOpsGuru.Types.StartTimeRange
import Amazonka.DevOpsGuru.Types.TagCollection
import Amazonka.DevOpsGuru.Types.TagCollectionFilter
import Amazonka.DevOpsGuru.Types.TagCostEstimationResourceCollectionFilter
import Amazonka.DevOpsGuru.Types.TagHealth
import Amazonka.DevOpsGuru.Types.TimestampMetricValuePair
import Amazonka.DevOpsGuru.Types.UpdateCloudFormationCollectionFilter
import Amazonka.DevOpsGuru.Types.UpdateResourceCollectionFilter
import Amazonka.DevOpsGuru.Types.UpdateServiceIntegrationConfig
import Amazonka.DevOpsGuru.Types.UpdateTagCollectionFilter
import Amazonka.DevOpsGuru.UpdateEventSourcesConfig
import Amazonka.DevOpsGuru.UpdateResourceCollection
import Amazonka.DevOpsGuru.UpdateServiceIntegration
